<script type="text/html" data-template-name="facial-webhooks">
  <div class="form-row">
    <label for="node-input-method"><i class="fa fa-tasks"></i> <span data-i18n="method"></span></label>
    <select type="text" id="node-input-method" style="width:70%;">
        <option value="POST">POST</option>
        <option value="PUT">PUT</option>
        <option value="DELETE">DELETE</option>
        <option value="GET">GET</option>
        <option value="HEAD">HEAD</option>
    </select>
  </div>

  <div class="form-row">
      <label for="node-input-url"><i class="fa fa-globe"></i> <span data-i18n="url"></span></label>
      <input id="node-input-url" type="text" placeholder="http://">
  </div>
  <div class="form-row">
      <input type="checkbox" id="node-input-usetls" style="display: inline-block; width: auto; vertical-align: top;">
      <label for="node-input-usetls" style="width: auto" data-i18n="enable-secure-connection"></label>
      <div id="node-row-tls" class="hide">
          <label style="width: auto; margin-left: 20px; margin-right: 10px;" for="node-input-tls" data-i18n="tls-configuration"></label><input type="text" style="width: 300px" id="node-input-tls">
      </div>
  </div>

  <div class="form-row">
      <input type="checkbox" id="node-input-useAuth" style="display: inline-block; width: auto; vertical-align: top;">
      <label for="node-input-useAuth" style="width: 70%;" data-i18n="use-authentication"></label>
      <div style="margin-left: 20px" class="node-input-useAuth-row hide">
          <div class="form-row">
              <label for="node-input-authType-select"><i class="fa fa-user-secret "></i> <span data-i18n="type"></span></label>
              <select type="text" id="node-input-authType-select" style="width:70%;">
                  <option value="basic" data-i18n="type-option.basic"></option>
                  <option value="digest" data-i18n="type-option.digest"></option>
                  <option value="bearer" data-i18n="type-option.bearer-token"></option>
              </select>
              <input type="hidden" id="node-input-authType">
          </div>
          <div class="form-row node-input-basic-row">
              <label for="node-input-user"><i class="fa fa-user"></i> <span data-i18n="username"></span></label>
              <input type="text" id="node-input-user">
          </div>
          <div class="form-row">
            <label for="node-input-password"> <i class="fa fa-lock"></i> 
              <span id="node-span-password" data-i18n="password"></span>
              <span id="node-span-token" style="display:none" data-i18n="token"></span>
            </label>
              <input type="password" id="node-input-password">
          </div>
      </div>
  </div>
  <div class="form-row">
    <input type="checkbox" id="node-input-includeImage" style="display: inline-block; width: auto; vertical-align: top;">
    <label for="node-input-includeImage" style="width: auto" data-i18n="include-dected-image"></label>
  </div>
  <div class="form-row">
      <label for="node-input-ret"><i class="fa fa-arrow-left"></i> <span data-i18n="return"></span></label>
      <select type="text" id="node-input-ret" style="width:70%;">
      <option value="txt"> UTF-8</option>
      <option value="bin"> Binary</option>
      <option value="obj"> JSON</option>
      </select>
  </div>
  <div class="form-row">
      <label for="node-input-name"><i class="fa fa-tag"></i> <span data-i18n="name"></span></label>
      <input type="text" id="node-input-name">
  </div>
  <div class="form-tips" id="tip-json" hidden><span data-i18n="httpin.tip.req"></span></div>
</script>


<script type="text/javascript">
  RED.nodes.registerType('facial-webhooks',{
      category: 'nilvana',
      color:"#A6ABF8",
      defaults: {
          name: {value:""},
          method:{value:"POST"},
          ret: {value:"txt"},
          url:{value:"",validate:function(v) { return (v.trim().length === 0) || (v.indexOf("://") === -1) || (v.trim().indexOf("http") === 0)} },
          tls: {type:"tls-config",required: false},
          authType: {value: ""},
          includeImage: {value: false}
      },
      credentials: {
          user: {type:"text"},
          password: {type: "password"}
      },
      inputs:1,
      outputs:1,
      outputLabels: function(i) {
          return ({
              txt: this._("httpin.label.utf8String"),
              bin: this._("httpin.label.binaryBuffer"),
              obj: this._("httpin.label.jsonObject")
          }[this.ret]);
      },
      icon: "icons/icon-nodes-webhook.png",
      label: function() {
          return this.name|| "facial webhooks";
      },
      labelStyle: function() {
          return this.name ? "node_label_italic":"";
      },
      oneditprepare: function() {
          $("#node-input-useAuth").on("change", function() {
              if ($(this).is(":checked")) {
                  $(".node-input-useAuth-row").show();
                  // Nodes (< version 0.20.x) with credentials but without authentication type, need type 'basic'
                  if (!$('#node-input-authType').val()) {
                      $("#node-input-authType-select").val('basic').trigger("change");
                  }
              } else {
                  $(".node-input-useAuth-row").hide();
                  $('#node-input-authType').val('');
                  $('#node-input-user').val('');
                  $('#node-input-password').val('');
              }
          });
          $("#node-input-authType-select").on("change", function() {
              var val = $(this).val();
              $("#node-input-authType").val(val);
              if (val === "basic" || val === "digest") {
                  $(".node-input-basic-row").show();
                  $('#node-span-password').show();
                  $('#node-span-token').hide();
              } else if (val === "bearer") {
                  $(".node-input-basic-row").hide();
                  $('#node-span-password').hide();
                  $('#node-span-token').show();
                  $('#node-input-user').val('');
              }
          });
          if (this.authType) {
              $('#node-input-useAuth').prop('checked', true);
              $("#node-input-authType-select").val(this.authType);
              $("#node-input-authType-select").change();
          } else {
              $('#node-input-useAuth').prop('checked', false);
          }
          $("#node-input-useAuth").change();

          function updateTLSOptions() {
              if ($("#node-input-usetls").is(':checked')) {
                  $("#node-row-tls").show();
              } else {
                  $("#node-row-tls").hide();
              }
          }
          if (this.tls) {
              $('#node-input-usetls').prop('checked', true);
          } else {
              $('#node-input-usetls').prop('checked', false);
          }
          updateTLSOptions();
          $("#node-input-usetls").on("click",function() {
              updateTLSOptions();
          });

          $("#node-input-ret").on("change", function() {
              if ($("#node-input-ret").val() === "obj") {
                  $("#tip-json").show();
              } else {
                  $("#tip-json").hide();
              }
          });
      },
      oneditsave: function() {
          if (!$("#node-input-usetls").is(':checked')) {
              $("#node-input-tls").val("_ADD_");
          }
      }
  });
</script>